## File Specification
ec_teacher_KD.log and fold_teacher.log are the log files that records the training losses, and metrics.

datasets.py gives some dataset functiuons to process data, including the amino acid types and the physicochemical properties of each residue, namely, a
steric parameter, hydrophobicity, volume, polarizability, isoelectric point, helix probability and sheet probability. 

losses.py gives the codes of the KL loss and CE loss.

get_KeAP_embeddings.py gives the codes for generating KeAP embeddings for proteins.

get_GO_embeddings.py is for teacher model to generate GO embeddings.

## Teacher Embeddings


## Installation

Install PyTorch 1.13.1:
```
pip install torch==1.13.1+cu117 torchvision==0.14.1+cu117 torchaudio==0.13.1 --extra-index-url https://download.pytorch.org/whl/cu117
```

Install PyG, transformers:
```
pip install torch-geometric
pip install transformers
```

Install PyTorch Scatter and PyTorch Sparse:
```
pip install torch_scatter torch_sparse -f https://data.pyg.org/whl/torch-1.13.1+cu117.html
```



### License
The code is released under MIT License.


### Related Repos
1. [CDConv](https://github.com/hehefan/Continuous-Discrete-Convolution) &emsp; 2. [GearNet](https://github.com/DeepGraphLearning/GearNet) &emsp; 3.[ESM](https://github.com/facebookresearch/esm) &emsp; 4.[KeAP](https://github.com/RL4M/KeAP)
